## mingw-w64-gst-plugins-rs-1.22.10-1.src.tar.zst

=== meson_options.txt ===
# Same order as members in Cargo.toml

# audio
option('audiofx', type: 'feature', value: 'auto', description: 'Build audiofx plugin')
option('claxon', type: 'feature', value: 'auto', description: 'Build claxon plugin')
option('csound', type: 'feature', value: 'auto', description: 'Build csound plugin')
option('lewton', type: 'feature', value: 'auto', description: 'Build lewton plugin')
option('spotify', type: 'feature', value: 'auto', description: 'Build spotify plugin')

# generic
option('file', type: 'feature', value: 'auto', description: 'Build file plugin')
option('sodium', type: 'feature', value: 'auto', description: 'Build sodium plugin')
option('sodium-source', type: 'combo',
       choices: ['system', 'built-in'], value: 'built-in',
       description: 'Whether to use libsodium from the system or the built-in version from the sodiumoxide crate')
option('threadshare', type: 'feature', value: 'auto', description: 'Build threadshare plugin')

# mux
option('flavors', type: 'feature', value: 'auto', description: 'Build flavors plugin')
option('fmp4', type: 'feature', value: 'auto', description: 'Build fmp4 plugin')
option('mp4', type: 'feature', value: 'auto', description: 'Build mp4 plugin')

# net
option('aws', type: 'feature', value: 'auto', description: 'Build aws plugin')
option('hlssink3', type: 'feature', value: 'auto', description: 'Build hlssink3 plugin')
option('ndi', type: 'feature', value: 'auto', description: 'Build ndi plugin')
option('onvif', type: 'feature', value: 'auto', description: 'Build onvif plugin')
option('raptorq', type: 'feature', value: 'auto', description: 'Build raptorq plugin')
option('reqwest', type: 'feature', value: 'auto', description: 'Build reqwest plugin')
option('rtp', type: 'feature', value: 'auto', description: 'Build rtp plugin')
option('webrtc', type: 'feature', value: 'auto', description: 'Build webrtc plugin')
option('webrtchttp', type: 'feature', value: 'auto', description: 'Build webrtchttp plugin')

# text
option('textahead', type: 'feature', value: 'auto', description: 'Build textahead plugin')
option('json', type: 'feature', value: 'auto', description: 'Build json plugin')
option('regex', type: 'feature', value: 'auto', description: 'Build regex plugin')
option('textwrap', type: 'feature', value: 'auto', description: 'Build textwrap plugin')

# utils
option('fallbackswitch', type: 'feature', value: 'auto', description: 'Build fallbackswitch plugin')
option('livesync', type: 'feature', value: 'auto', description: 'Build livesync plugin')
option('togglerecord', type: 'feature', value: 'auto', description: 'Build togglerecord plugin')
option('tracers', type: 'feature', value: 'auto', description: 'Build tracers plugin')
option('uriplaylistbin', type: 'feature', value: 'auto', description: 'Build uriplaylistbin plugin')

# video
option('cdg', type: 'feature', value: 'auto', description: 'Build cdg plugin')
option('closedcaption', type: 'feature', value: 'auto', description: 'Build closedcaption plugin')
option('dav1d', type: 'feature', value: 'auto', description: 'Build dav1d plugin')
option('ffv1', type: 'feature', value: 'auto', description: 'Build ffv1 plugin')
option('gif', type: 'feature', value: 'auto', description: 'Build gif plugin')
option('gtk4', type: 'feature', value: 'auto', description: 'Build GTK4 plugin')
option('hsv', type: 'feature', value: 'auto', description: 'Build hsv plugin')
option('png', type: 'feature', value: 'auto', description: 'Build png plugin')
option('rav1e', type: 'feature', value: 'auto', description: 'Build rav1e plugin')
option('videofx', type: 'feature', value: 'auto', description: 'Build videofx plugin')
option('webp', type: 'feature', value: 'auto', description: 'Build webp plugin')

# Common options
option('doc', type: 'feature', value: 'auto', yield: true,
       description: 'Enable documentation')
option('examples', type: 'feature', value: 'disabled', yield: true,
       description: 'Build examples')
option('tests', type : 'feature', value : 'auto', yield : true,
       description : 'Build and enable unit tests')

=== PKGBUILD ===
# Maintainer: Mazhar Hussain <realmazharhussain@gmail.com>

_realname=gst-plugins-rs
pkgbase=mingw-w64-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-${_realname}
pkgdesc='GStreamer plugins written in Rust (mingw-w64)' 
url="https://gitlab.freedesktop.org/gstreamer/$_realname"
pkgver=1.22.10
_tag=gstreamer-$pkgver
pkgrel=1
license=('spdx:LGPL-3.0-or-later'
         'spdx:Apache-2.0'
         'spdx:MIT'
         'spdx:MPL-2.0')
depends=(${MINGW_PACKAGE_PREFIX}-gtk4
         ${MINGW_PACKAGE_PREFIX}-libsodium
         ${MINGW_PACKAGE_PREFIX}-gstreamer
         ${MINGW_PACKAGE_PREFIX}-gst-plugins-base
         ${MINGW_PACKAGE_PREFIX}-gst-plugins-bad-libs
         ${MINGW_PACKAGE_PREFIX}-libwebp)
makedepends=(${MINGW_PACKAGE_PREFIX}-pkgconf
             ${MINGW_PACKAGE_PREFIX}-rust
             ${MINGW_PACKAGE_PREFIX}-cargo-c)
source=("$url/-/archive/$_tag/$_realname-gstreamer-$_tag.tar.bz2")
sha256sums=('13e375dee501b4f5dc1765531533b381bae65a5fac19744823a02ca79893e8be')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
arch=(any)

prepare() {
  mv "$_realname-$_tag-"* "$_realname-$_tag"
  cd $_realname-$_tag
  cargo fetch
}

_cargo_opts=(--workspace
             --offline
             --release
             --library-type=cdylib
             --prefix="${MINGW_PREFIX}"
             --exclude gst-plugin-csound
             --exclude gst-plugin-dav1d  # not compatiple with dav1d 1.3.0 yet
             --exclude gst-plugin-aws)

build() {
  cd $_realname-$_tag
  MSYS2_ARG_CONV_EXCL="--prefix=" cargo cbuild "${_cargo_opts[@]}"
}

check() {
  cd $_realname-$_tag
  MSYS2_ARG_CONV_EXCL="--prefix=" cargo ctest "${_cargo_opts[@]}" --target-dir=tests-build
}

package() {
  cd $_realname-$_tag
  MSYS2_ARG_CONV_EXCL="--prefix=" cargo cinstall "${_cargo_opts[@]}" --destdir="$pkgdir"
  install -Dm644 -t "$pkgdir/$MINGW_PREFIX"/share/licenses/$_realname/ LICENSE*
}
